<?php 
require_once('config.php'); ?>
<?php

	if (isset($_GET['nyaaid'])) 
	{
	$db = new SQLite3($config_db);
	$db->busyTimeout($config_db_timeout);
	$results = $db->query("SELECT nyaaid FROM $config_table_info ");
		header('Content-type: application/octet-stream');
		header('Content-Disposition: attachment; filename="nyaaid.txt"');
		while ($row = $results->fetchArray()) 
		{
		echo "".$row['nyaaid'].""."\n";
		}
	die;
	}
	
	
	if (isset($_GET['btih'])) 
	{
	$db = new SQLite3($config_db);
	$db->busyTimeout($config_db_timeout);
	$results = $db->query("SELECT btih FROM $config_table_info ");
	header('Content-type: application/octet-stream');
	header('Content-Disposition: attachment; filename="btih.txt"');
		while ($row = $results->fetchArray()) 
		{
		echo "".$row['btih'].""."\n";
		}
	die;
	}
	
	if (isset($_GET['xml'])) 
	{
		$expire = time() -604800 ;
		$exportfile = './export.xml.zip';
		if (file_exists($exportfile) && filemtime($exportfile) > $expire) {
    	header('Location: export.xml.zip');
		} else {
		unlink($exportfile);
 	$db = new SQLite3($config_db);
	$db->busyTimeout($config_db_timeout);
	$count = $db->query("SELECT Count(*) FROM $config_table_info ");
	$results = $db->query("SELECT * FROM $config_table_info ");
	$results2 = $db->query("SELECT * FROM $config_table_stat ");
		$fp = fopen('export.xml', 'w');
		fwrite($fp, "<?xml version='1.0' encoding='utf-8'?>\n");
		fwrite($fp, "<items>\n");
		while ($row = $results->fetchArray() and $row2 = $results2->fetchArray()) 
		{
		fwrite($fp, "<item>\n");
		fwrite($fp, "<id>".$row['nyaaid']."</id>\n");
		fwrite($fp, "<category>".$row['cat']."</category>\n");
		fwrite($fp, "<date>".$row['date']."</date>"."\n");
		fwrite($fp, "<submitter>".$row['submitter']."</submitter>\n");
		fwrite($fp, "<btih>".$row['btih']."</btih>\n");
		fwrite($fp, "<name>".$row['name']."</name>"."\n");
		fwrite($fp, "<torrentname>".$row['tname']."</torrentname>\n");
		fwrite($fp, "<size>".$row['size']."</size>\n");
		fwrite($fp, "<updated>".$row2['updated']."</updated>\n");
		fwrite($fp, "<seeders>".$row2['seed']."</seeders>\n");
		fwrite($fp, "<leechers>".$row2['leech']."</leechers>\n");
		fwrite($fp, "<downloads>".$row2['downloads']."</downloads>\n");
		fwrite($fp, "</item>\n");
		}
		fwrite($fp, "</items>");
		fclose ($fp);

		$zip = new ZipArchive();
		if ($zip->open($exportfile, ZIPARCHIVE::CREATE)!==TRUE) {
   		 exit("Cannot open <$exportfile>\n");
		}
		$zip->addFile("export.xml","export.xml");
		$zip->close();
		unlink('export.xml');
		header('Location: export.xml.zip');
		}
	}
	
	if (isset($_GET['csv'])) 
	{
	$db = new SQLite3($config_db);
	$db->busyTimeout($config_db_timeout);
	$results = $db->query("SELECT * FROM $config_table_info ");
	$results2 = $db->query("SELECT * FROM $config_table_stat ");
	header('Content-type: application/octet-stream');
	header('Content-Disposition: attachment; filename="export.csv"');
		echo "\"nyaaid\",\"category\",\"date\",\"submitter\",\"btih\",\"name\",\"torrentname\",\"size\",\"updated\",\"seeders\",\"leechers\""."\n";
			while ($row = $results->fetchArray() and $row2 = $results2->fetchArray()) 
			{
			echo "\"".$row['nyaaid']."\",\"".$row['cat']."\",\"".$row['date']."\",\"".$row['submitter']."\",\"".$row['btih']."\",\"".$row['name']."\",\"".$row['tname']."\",\"".$row['size']."\",\"".$row2['updated']."\",\"".$row2['seed']."\",\"".$row2['leech']."\""."\n";
			}
	die;
	}




$actualpage = preg_replace('/[^0-9]+/', '', $_GET['page']); // strip out letters and stuff... ultimate powers to the numbers !
if ($actualpage != '') {
}
else {
$actualpage = "1";  // what's left is empty ? Ok, let's say we need page 1.
}
if ($actualpage < "1") {
header("HTTP/1.0 404 Not Found");
$actualpage = "1";
$offlimit="<br><b>Oh come on, you requested page zero... I show you page 1 instead.</b>";  // self-explanatory
}
if ($actualpage > "1") {
$minuspage = ($actualpage-1);  // set previous page number
}
else {
$minuspage = "1";  // we're at page 1 ? previous is 1.
}
$limit = "100";  // show 100 results
$offset = ($actualpage*100-100);  // set the offset at x-100 rows 
$db = new SQLite3($config_db);
$db->busyTimeout($config_db_timeout); // maximum 10 second delay if database is locked (when data is inserted/updated)
$count = $db->query("SELECT Count(*) FROM $config_table_info ");  // let's count the torrents
$results = $db->query("SELECT nyaaid, cat, date, submitter, btih, name, tname, size FROM $config_table_info ORDER BY nyaaid DESC LIMIT $limit OFFSET $offset ");  // let's extract torrent data
$results2 = $db->query("SELECT nyaaid, updated, seed, leech FROM $config_table_stat ORDER BY nyaaid DESC LIMIT $limit OFFSET $offset ");   // extract stuff from track

while ($rowcount = $count->fetchArray()) 
{
$countnumber=$rowcount["Count(*)"];
$pagecount=floor(($countnumber/100+1));
$text_count=$countnumber." torrents indexed. (".$pagecount." pages)<br>";  // showing how much we got
}

if ($actualpage < $pagecount) {
$pluspage = ($actualpage+1);   // we're at page X ? plus is X +1.
}
else {
$pluspage = $actualpage;    // we're at page "pagecount" ? plus is "pagecount". (not getting spiders into infinite loop requesting more and more pagenumbers)
}

if ($pagecount < $actualpage) {
header("HTTP/1.0 404 Not Found");
$offlimit="<br><br><b>There aren't so much torrents indexed. Sorry.</b>";  // Kevin did see too big manually ? Let's bring him back on the right path.
$minuspage=$pagecount;
$pluspage=$pagecount;
}  // and now, showtime !
?>


<!DOCTYPE html>
<html dir="ltr" lang="en">
<head>
<meta charset="UTF-8">
<title><?php echo $config_title; ?> *full database*</title>
<meta name="description" content="<?php echo $config_description; ?> *full database*">
<meta name="robots" content="index, follow">
<style type="text/css">
<?php echo $config_css; ?>
</style>
</head>
<body>
<h1><?php echo $config_title; ?></h1>
<h2><?php echo $config_description; ?></h2>

<?php echo "<a href=\".\">&larr; back</a><br><br>Browsing the database. You can also download a <a href=\"./fulldb.php?nyaaid\">NyaaID list</a> (text), a <a href=\"./fulldb.php?btih\">btih list</a> (text), and a full database dump as <a href=\"./fulldb.php?csv\">CSV</a> or <a href=\"./fulldb.php?xml\">XML</a>.<br><b>Full database:</b><br><br>";
echo $text_count;
echo "<form id=\"jump\" action=\"./fulldb.php\" method=\"get\"><p><input type=\"text\" name=\"page\" placeholder=\"Page\"><input type=\"submit\" value=\"Jump!\"></p></form><br><a href=\"?page=".$minuspage."\">&larr; next 100 torrents</a> | page: ".$actualpage." | <a href=\"?page=".$pluspage."\">previous 100 torrents &rarr;</a>";
echo $offlimit;
echo "<br><table><tbody>"."\n"; 
while ($row = $results->fetchArray() and $row2 = $results2->fetchArray()) 
{
echo "<tr><td class=\"full\">".$row['nyaaid']."</td><td class=\"full\">".$row['cat']."</td><td class=\"full\"><a href=\"magnet:?xt=urn:btih:".$row['btih']."\"><img alt=\"magnet\" src=\"magnet.png\"></a>  <a href=\"index.php?nyaaid=".$row['nyaaid']."\">".$row['name']."</a></td><td style=\"text-align:right;\" class=\"full\">".round($row['size']/1048576, 2)." MB</td><td class=\"full\">SE: ".$row2['seed']." LE: ".$row2['leech']."</td></tr>"."\n";
}
echo "</tbody></table>";
echo $config_footer;
?>
</body>
</html>
